<?php
namespace Ep\Wp\Test;

use Ep\Wp\ConfigProvider;
use Ep\Wp\Plugin\PluginInterface;
use Ep\Wp\Plugin\PluginManager;
use EpTest\ContainerAwareTrait;
use WP_UnitTestCase;
use Zend\ServiceManager\PluginManagerInterface;

if (!class_exists(\PHPUnit_Framework_TestCase::class)) {
    class_alias(\PHPUnit\Framework\TestCase::class, \PHPUnit_Framework_TestCase::class, true);
}

abstract class AbstractWordPressTest extends WP_UnitTestCase
{
    use ContainerAwareTrait;

    protected function getPluginManager(array $additionalConfig = []): PluginManagerInterface
    {
        $container = $this->createContainer(array_merge((new ConfigProvider())(), $additionalConfig));
        return $container->get(PluginManager::class);
    }

    protected function getPlugin(string $name, array $additionalConfig = []): PluginInterface
    {
        $plugins = $this->getPluginManager($additionalConfig);
        return $plugins->get($name);
    }
}